﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using ProcessSimulationInterfaces;

namespace ProcessSimulationSystem
{
    public class AD_DA_Convert
    {
        private const int Analog2DigitalDelayTime = 1;
        private const double speedMeasuringFactor = 10d;
        private const double positionMeasuringFactor = 0.2d;
        public static double DigitalInput2AnalogPower(int digitalvalue)
        {
            // cut off by 8 bit
            if (digitalvalue < -128)
                digitalvalue = -128;
            else if (digitalvalue > 127)
                digitalvalue = 127;
            return digitalvalue*0.1;   // 1.27 fuld power
        }
        public static int AnalogSpeed2Digital(double analogValue)
        {
            analogValue = analogValue * speedMeasuringFactor; // convert factor
            if (analogValue < -128)
                analogValue = - 128;
            else if (analogValue > 127)
                analogValue = 127;
            //            for (int i = 0; i < 10000; ++i) ; // active delay
            System.Threading.Thread.Sleep(Analog2DigitalDelayTime);
            return (int)analogValue;
        }
        public static int AnalogPosition2Digital(double analogValue)
        {
            analogValue = analogValue * positionMeasuringFactor; // measurement convert factor to 8-bit
            if (analogValue < -128)
                analogValue = -128;
            else if (analogValue > 127)
                analogValue = 127;
            //            for (int i = 0; i < 10000; ++i) ; // active delay
            System.Threading.Thread.Sleep(Analog2DigitalDelayTime);
            return (int)analogValue;
        }

    }
}
