﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProcessSimulationInterfaces;

namespace ProcessSimulationSystem
{
    public class DigitalValue : INotifyPropertyChanged
    {
        private int value;
        private object valuelock = new object();

        public void SetValue(int value)
        {
            lock (valuelock)
            {
                this.value = value;
                NotifyPropertyChanged("Value");
            }
        }
        public int GetValue()
        {
            lock (valuelock)
                return this.value;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }
}
